/* $Id: shared.h,v 2.7 2015/11/08 09:31:46 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 2.7 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@siilo.FMI.FI> 
 *                  (was hurtta+elm@posti.FMI.FI, hurtta+elm@ozone.FMI.FI)
 *       or Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/

#ifndef SHARED_H
#define SHARED_H 1

/* This is included on both elmshared.h and shared_imp.h */

/* --------------------------------------------------------------- */

#include <dlfcn.h>

#ifdef ANSI_C
struct SE_option;
struct  map_info;
struct  charset_type;
struct mailer_info_1;
struct smtp_callbacks;
struct remote_account;
#endif

typedef int pop_capa_handler P_((struct folder_info *folder,
				 char *capa,
				 char *capa_args,
				 size_t fi_size,
				 struct pop_callbacks *commands,
				 size_t cb_size,
				 struct SE_option   *service_config,
				 size_t sc_size,
				 enum CAPA_phase *phase));

typedef int imap_capa_handler P_((struct connection_cache *con,
				  char *capa,
				  size_t con_size,
				  struct imap_callbacks *commands,
				  size_t cb_size,
				  struct SE_option   *service_config,
				  size_t sc_size,
				  enum CAPA_phase *phase));

typedef int smtp_ext_handler P_((struct mailer_info_1 *mailer_info,
				  char * ext,
				 char * ext_args,
				  size_t mailer_info_size,
				  struct smtp_callbacks *cb, 
				  size_t cb_size,
				  struct SE_option   *service_config,
				  size_t sc_size,
				  enum CAPA_phase *phase));
				  
typedef struct folder_type ** 
provides_shared_FT_f P_((int *count, size_t *s_size));

typedef struct provides_shared_POP_CAPA {
    char                * capa;
    int                   priority;
    pop_capa_handler     *capa_handler;
}  *  provides_shared_POP_CAPA_f P_((int *count, size_t *s_size));

typedef struct provides_shared_IMAP_CAPA {
    char                * capa;
    int                   priority;
    imap_capa_handler     *capa_handler;
}  *  provides_shared_IMAP_CAPA_f P_((int *count, size_t *s_size));

typedef struct provides_shared_SMTP_EXT {
    char                * ext;
    int                   priority;
    smtp_ext_handler    * ext_handler;	
} *  provides_shared_SMTP_EXT_f P_((int *count, size_t *s_size));

typedef struct SE_option_type ** 
provides_shared_SEOT_f  P_((int *count, size_t *s_size));

typedef struct rc_save_info_rec
* provides_RC_options_f P_((int *count, size_t *s_size));

typedef void RC_post_init_f P_((int *errors));

typedef void wants_rand_bits_f P_((const char *buf, int size, 
				   int entropy_bits));

typedef enum tls_ra_status {
    tls_ra_unsupported = -2 /* initial tls unsupported */,
    tls_ra_failed = -1    /* initial tls negation failed */,
    tls_ra_none   = 0     /* initial tls disabled        */,
    tls_ra_done   = 1     /* initial tls done            */
} provides_initial_TLS_ra_f P_((struct remote_account * ra,
				const char            * proto_name, /* for messages */
				struct SE_option      * service_config,
				size_t                  sc_size         ));

typedef int CS_auto_charset_f P_((const char *name,
				  struct  charset_type **type,
				  struct  map_info **map));

typedef struct mailer_config *
provides_shared_MCF_f P_((int *count, size_t *s_size, size_t *opt_size,
			  size_t *s_send_state_size, size_t *s_cancel_size,
			  size_t *s_mailer_info_size, 
			  size_t *s_env_from_size));

typedef void init_library_REG_f P_((void));

#endif

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
